package hdm.mi.growbros.controllers;

import hdm.mi.growbros.models.plant.Plant;
import hdm.mi.growbros.service.GardenService;
import lombok.RequiredArgsConstructor;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping("/api/v1/garden")
@RequiredArgsConstructor
public class GardenController {
    private final GardenService gardenService;

    @GetMapping("/")
    public List<Plant> getPlantsInGarden(@RequestParam(value = "sort", required = false) String sort) {
        //TODO: get the user by adding (Authentication authentication) as params
        /*
         * Sort: name of plants, added to list on, next possible planting date, next possible harvest
         */
        System.out.println(sort);
        return gardenService.getUserPlants(0L, sort);
    }

    @PostMapping("/add/{plantId}")
    public void addPlantToGarden(@PathVariable Long plantId) {
        gardenService.addPlantToGarden(plantId, 0L);
    }

    @DeleteMapping("/remove/{entryId}")
    public void removePlantFromGarden(@PathVariable Long entryId) {
        gardenService.removeFromGarden(entryId);
    }

    @DeleteMapping("/remove/all")
    public Long removeAllPlantsFromGarden() {
        return gardenService.clearGarden();
    }

}
