package hdm.mi.growbros.repositories;

import hdm.mi.growbros.models.GardenEntry;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface GardenRepository extends JpaRepository<GardenEntry, Long> {
    @Query("""
                SELECT e FROM GardenEntry e
                ORDER BY ABS(:week - e.plant.harvestWeekStart) ASC
            """)
    List<GardenEntry> findNearestHarvestWeek(@Param("week") int currentWeek);
}
