package hdm.mi.growbros.service;

import hdm.mi.growbros.models.plant.Plant;
import hdm.mi.growbros.repositories.PlantRepository;
import lombok.RequiredArgsConstructor;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;

@Service
@RequiredArgsConstructor
public class PlantsService {
    private final static Logger log = LoggerFactory.getLogger(PlantsService.class);

    private final PlantRepository plantRepository;

    public Collection<Plant> getPlants() {
        return plantRepository.findAll();
    }

    public void createPlant(Plant plant) {
        log.info("Saving plant '{}' to repository.", plant.getName());
        plantRepository.save(plant);
    }

    public List<Plant> search(String search) {
        return plantRepository.findByNameIsLike(search);
    }
}
